/*  Program Pyramida, version 0.3 (16. 9. 2002)
 *  Copyright (C) 2002  Martin Beranek <marble@matfyz.cz>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "data.h"


DATAFILE *dat = NULL;

int load_images(struct t_game_gfx *gm, BITMAP **bg)
{
	if (dat == NULL) {
		dat = load_datafile(DATAFILE_FN);
		if (dat == NULL)
			return 0;
	}

	gm->b_st[WHITE] = dat[BMP_WHITE].dat;
	gm->b_st[BLACK] = dat[BMP_BLACK].dat;
	gm->b_none = dat[BMP_NONE].dat;
	gm->b_bg = dat[BMP_BRD_BG].dat;
	
	gm->b_left = dat[BMP_WHITE_BG].dat;
	gm->b_right = dat[BMP_BLACK_BG].dat;

	*bg = dat[BMP_ALL_BG].dat;
	
	return 1;
}

char *get_pokec()
{
	if (dat == NULL) {
		dat = load_datafile(DATAFILE_FN);
		if (dat == NULL)
			return NULL;
	}

	return dat[TXT_POKEC].dat;
}

void release_data()
{
	unload_datafile_object(dat);
}

