#ifndef __GFX_H__
#define __GFX_H__

#include <allegro.h>
#include "game.h"

/* skalovani souradnic desky na souradnice sveta */
#define R	40
#define Ry	57

/* souradnice kamery (uz v pixelovych rozmerech) */
#define cam_x	0
#define cam_y	0
#define cam_z	itofix(-20*R)

/* vzdalenost "projekcniho platna" kamery */
#define cam_foc	itofix(20*R)


/* velikost okna pro desku */
#define BRDW_W	492
#define BRDW_H	492

/* souradnice stredu(!) okna desky */
/*#define BRDW_X	400
#define BRDW_Y	246
*/

struct t_stone_gfx {
	int gx, gy;	// souradnice na obrazovce ... [0; 0] je ve stredu
	int gd;		// prumer gule na onrazovce
	
	fixed dst;	// vzdalenost od kamery - pro srovnani kamenu
};
	

struct t_game_gfx {
	fixed u1, u2;	// uhly natoceni desky - u1 kolem x-ove souradnice a pak u2 kolem y-ove
	MATRIX m;	// transf. matice desky

	struct t_stone_gfx g_st[STONES];
	int s_st[STONES];	// pole id serazenych kamenu

	int ghost;	// id kamenu, ktery je "duch"
	int hd1, hd2;	// id kamenu, ktere "nejsou zrovna videt"

	struct t_game *gm;
	struct t_stone *st;

	BITMAP *bg;

	BITMAP *b_st[2];
	BITMAP *b_none;
	BITMAP *b_bg;

	BITMAP *b_left;
	BITMAP *b_right;
};

/* inicializuje vse potrebne :-) */
int init_game_gfx(struct t_game_gfx *gm_gfx, struct t_game *gm);

/* spocita tr. matici, prepocita souradnice sutru a seradi s_st[] */
void recalc_board_gfx(struct t_game_gfx *gm);

/* nakresli desku (tj. kameny) a pozadi na bitmapu bg */
void draw_stones(struct t_game_gfx *gm);

/* zkopiruje kameny na obrazovku */
void blit_board(struct t_game_gfx *gm, int x, int y);

/* vrati id kamenu na ktery ukazuje kurzor */
int get_stone_id(struct t_game_gfx *gm, int mx, int my, int add, int max_y, int orig_id);

/* nakresli zasobniky kamenu; nejvrchnejsi kamen barvy gh nakresli pruhledny */
void draw_bufs(struct t_game_gfx *gm, int gh, int x, int y, int p);

#endif

