/*  Program Pyramida, version 0.3 (16. 9. 2002)
 *  Copyright (C) 2002  Martin Beranek <marble@matfyz.cz>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



#include "ui.h"

DIALOG *game_w, *white_w, *black_w, *info_w;

DIALOG *main_d;

int main_d_exit = 0;


#define CPU_MOVE_DELAY	300	// pauza mezi jednotlivymi kroky CPU tahu (pri zobrazovani)
int cpu_move_step;
volatile int cpu_move_flag;

void cpu_move_timer() {
	cpu_move_flag++;
}

END_OF_FUNCTION(cpu_move_timer);

void lock_timer_stuff()
{
	LOCK_VARIABLE(cpu_move_flag);
	LOCK_FUNCTION(cpu_move_timer);
}

int val;
struct t_move cpu_mv;

/* az sem je to ruzny binec souvisejici s pridanim animovani CPU tahu */

void do_info_dialog()
{
	DIALOG info_d[] =
	{
   	/* (dialog proc)	(x)   (y)   (w)   (h) (fg)	(bg) (key) (flags) (d1) (d2) (dp) (dp2) (dp3) */
	   {d_shadow_box_proc,	  0,	0,  680,  450, 0, 0xffffff, 0,      0, 0, 0,     NULL, NULL, NULL},
	   {d_textbox_proc,	 10,   10,   660,   404, 0, 0xffffff, 0,  0,  0, 0, NULL, NULL, NULL},
	   {d_button_proc,	 290,  424,  100,   16, 0, 0xffffff, 'z', D_EXIT, 0, 0, "&Zavrit", NULL, NULL},
	   {d_yield_proc,	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, NULL},
	   {NULL,		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, NULL}
	};

	info_d[1].dp = get_pokec();
	centre_dialog(info_d);

	popup_dialog(info_d, 2);
}

#define MENU_DLG_HRA_ID		14
#define MENU_DLG_END_ID		15
#define MENU_DLG_POKEC_ID	16
#define MENU_DLG_RADIO_W_ID	 5
#define MENU_DLG_RADIO_B_ID	11

int do_menu_dialog(struct t_player *players)
{
	char nm_w[51], nm_b[51];
	int r;
	DIALOG menu_d[] =
	{
   	/* (dialog proc)	(x)   (y)   (w)   (h) (fg)	(bg) (key) (flags) (d1) (d2) (dp) (dp2) (dp3) */
	   {d_shadow_box_proc,	  0,	0,  335,  160, 0, 0xffffff, 0,      0, 0, 0,     NULL, NULL, NULL},
   
	   {d_text_proc,	 20,   40,   40,   10, 0, 0xffffff, 0,      0,  0, 0, "Jmeno", NULL, NULL},
   
	   {d_ctext_proc,	125,   20,  100,   10, 0, 0xffffff, 0,          0,  0, 0,    "Bily", NULL, NULL},
	   {d_box_proc,	 	 70,   37,  110,   14, 0, 0xffffff, 0,          0,  0, 0,      NULL, NULL, NULL},
	   {d_edit_proc,	 75,   40,  100,   10, 0, 0xffffff, 0,          0, sizeof(nm_b)-1, 0,      nm_w, NULL, NULL},
	   {d_radio_proc,	 85,   65,   90,   10, 0, 0xffffff, 0,          0,  1, 0,  "Clovek", NULL, NULL},
	   {d_radio_proc,	 85,   80,   90,   10, 0, 0xffffff, 0,          0,  1, 0, "Pocitac", NULL, NULL},
	   {d_radio_proc,	 85,   95,   90,   10, 0, 0xffffff, 0, D_DISABLED,  1, 0,     "Sit", NULL, NULL},
   
	   {d_ctext_proc,	260,   20,  100,   10, 0, 0xffffff, 0,          0,  0, 0,    "Cerny", NULL, NULL},
	   {d_box_proc,	 	205,   37,  110,   14, 0, 0xffffff, 0,          0,  0, 0,      NULL, NULL, NULL},
	   {d_edit_proc,	210,   40,  100,   10, 0, 0xffffff, 0,          0, sizeof(nm_b)-1, 0,      nm_b, NULL, NULL},
	   {d_radio_proc,	220,   65,   90,   10, 0, 0xffffff, 0,          0,  2, 0,  "Clovek", NULL, NULL},
	   {d_radio_proc,	220,   80,   90,   10, 0, 0xffffff, 0,          0,  2, 0, "Pocitac", NULL, NULL},
	   {d_radio_proc,	220,   95,   90,   10, 0, 0xffffff, 0, D_DISABLED,  2, 0,     "Sit", NULL, NULL},
   
	   {d_button_proc,	 20,  125,  85,   16, 0, 0xffffff, 'h', D_EXIT, 0, 0, "&Hra", NULL, NULL},
	   {d_button_proc,	125,  125,  85,   16, 0, 0xffffff, 'k', D_EXIT, 0, 0, "&Konec", NULL, NULL},
	   {d_button_proc,	230,  125,  85,   16, 0, 0xffffff, 'i', D_EXIT, 0, 0, "&Info", NULL, NULL},

	   {d_yield_proc,	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, NULL},
	   {NULL,		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, NULL}
	};

	ustrzcpy(nm_w, sizeof(nm_w), players[WHITE].name);
	ustrzcpy(nm_b, sizeof(nm_b), players[BLACK].name);
	
	if (players[WHITE].ai == 0) {
		menu_d[MENU_DLG_RADIO_W_ID].flags |= D_SELECTED;
		menu_d[MENU_DLG_RADIO_W_ID+1].flags &= ~D_SELECTED;
	} else {
		menu_d[MENU_DLG_RADIO_W_ID].flags &= ~D_SELECTED;
		menu_d[MENU_DLG_RADIO_W_ID+1].flags |= D_SELECTED;
	}
	if (players[BLACK].ai == 0) {
		menu_d[MENU_DLG_RADIO_B_ID].flags |= D_SELECTED;
		menu_d[MENU_DLG_RADIO_B_ID+1].flags &= ~D_SELECTED;
	} else {
		menu_d[MENU_DLG_RADIO_B_ID].flags &= ~D_SELECTED;
		menu_d[MENU_DLG_RADIO_B_ID+1].flags |= D_SELECTED;
	}
	
	centre_dialog(menu_d);

	do {
		r = popup_dialog(menu_d, 4);

		if (r == MENU_DLG_POKEC_ID)
			do_info_dialog();

	} while ((r != MENU_DLG_END_ID) && (r != MENU_DLG_HRA_ID));
	
	if (r == MENU_DLG_HRA_ID) {

		free(players[WHITE].name);
		free(players[BLACK].name);
		players[WHITE].name = ustrdup(nm_w);
		players[BLACK].name = ustrdup(nm_b);
		if (menu_d[MENU_DLG_RADIO_W_ID].flags & D_SELECTED)
			players[WHITE].ai = 0;
		else
			players[WHITE].ai = 1;
		if (menu_d[MENU_DLG_RADIO_B_ID].flags & D_SELECTED)
			players[BLACK].ai = 0;
		else
			players[BLACK].ai = 1;
	
		return 1;
	}
	return 0;
}


DIALOG *init_main_d(struct t_game_gfx *game_gfx, struct t_player *players)
{
	struct t_d_game_data *d_game_data;
	
	d_game_data = malloc(sizeof(struct t_d_game_data));
	d_game_data->gh_id = -1;
	d_game_data->gmode = G_ADD;
	d_game_data->m.s1 = -1;
	d_game_data->amove = AMOVE_PUT;
	d_game_data->movebuf = 1;
	
	main_d = malloc(MAIN_D_ITMS * sizeof(DIALOG));
	memset(main_d, 0, MAIN_D_ITMS * sizeof(DIALOG));
	
	game_w = &(main_d[1]);
	white_w = &(main_d[2]);
	black_w = &(main_d[3]);
	info_w = &(main_d[0]);

	main_d[4].proc = d_esc_proc;
	
	/* multitasking friendly ... ??? No, rozhodne to tu neskodi. ;-) */
	main_d[5].proc = d_yield_proc;
	
	info_w->proc = d_info_proc;
	info_w->x = 20;				info_w->y = 512;
	info_w->w = 760;				info_w->h = 68;
	info_w->fg = makecol(0, 192, 0);		info_w->bg = makecol(0, 0, 0);
	info_w->key = 0;
	info_w->flags = 0;
	info_w->d1 = 6;			info_w->d2 = 10;
	info_w->dp = NULL;		info_w->dp2 = NULL;		info_w->dp3 = NULL;

	white_w->proc = d_buf_proc;
	white_w->x = 0;				white_w->y = 0;
	white_w->w = game_gfx->b_left->w;	white_w->h = game_gfx->b_left->h;
	white_w->fg = makecol(255, 255, 255);	white_w->bg = makecol(0, 0, 0);
	white_w->key = 0;
	white_w->flags = 0;
	white_w->d1 = WHITE;		white_w->d2 = 0;
	white_w->dp = game_gfx;		white_w->dp2 = d_game_data;	white_w->dp3 = &(players[WHITE]);

	black_w->proc = d_buf_proc;
	black_w->x = SCREEN_W - game_gfx->b_right->w;	black_w->y = 0;
	black_w->w = game_gfx->b_right->w;		black_w->h = game_gfx->b_right->h;
	black_w->fg = makecol(0, 192, 0);		black_w->bg = makecol(0, 0, 0);
	black_w->key = 0;
	black_w->flags = 0;
	black_w->d1 = BLACK;		black_w->d2 = 0;
	black_w->dp = game_gfx;		black_w->dp2 = d_game_data;	black_w->dp3 = &(players[BLACK]);

	game_w->proc = d_game_proc;
	game_w->x = (SCREEN_W - BRDW_W)>>1;	game_w->y = 0;
	game_w->w = BRDW_W;			game_w->h = BRDW_H;
	game_w->fg = makecol(255, 255, 255);	game_w->bg = makecol(0, 0, 0);
	game_w->key = 0;
	game_w->flags = 0;
	game_w->d1 = 0;			game_w->d2 = 0;
	game_w->dp = game_gfx;		game_w->dp2 = d_game_data;	game_w->dp3 = players;

	return main_d;
}


int d_game_proc(int msg, DIALOG *d, int c)
{
	struct t_game_gfx *game_gfx = d->dp;
	struct t_d_game_data *d_game_data = d->dp2;
	struct t_player *players = d->dp3;
	int k, i, p;
	char *s, *s2;

	/* aby nebyly problemy s prekreslovanim ... */
	if ((d->flags & D_DIRTY) && (msg != MSG_DRAW)) {
		scare_mouse();
		acquire_screen();
		draw_stones(game_gfx);
		blit_board(game_gfx, d->x, d->y);
		release_screen();
		unscare_mouse();
		d->flags &= ~D_DIRTY;
	}

	/* tohle by se melo provedst vzdycky */
	switch (msg) {
		case MSG_START:
			cpu_move_step = -1;
			recalc_board_gfx(game_gfx);
			s = malloc(ustrsize(players[game_gfx->gm->p].name) + ustrsizez(STRING_NEXT));
			usprintf(s, STRING_NEXT, players[game_gfx->gm->p].name);
			d_info_add_line(info_w, s);
			free(s);
			return D_O_K;
		case MSG_END:
			remove_int(cpu_move_timer);	/* odstrani timer */
			return D_O_K;
		case MSG_DRAW:
			draw_stones(game_gfx);
			blit_board(game_gfx, d->x, d->y);
			d->flags &= ~D_DIRTY;
			return D_O_K;
		case MSG_WANTFOCUS:
			return D_WANTFOCUS;
		case MSG_CHAR:
			k = c>>8;
			switch (k) {
				case KEY_UP:
					clear_keybuf();	// at to nedela problemy na pomalych pocitacich, ktery nestihaj kreslit
					game_gfx->u1 -= itofix(4);
					game_gfx->u1 &= 0xffffff;
					recalc_board_gfx(game_gfx);
					d->flags |= D_DIRTY;
					return D_USED_CHAR | D_REDRAW;
				case KEY_DOWN:
					clear_keybuf();
					game_gfx->u1 += itofix(4);
					game_gfx->u1 &= 0xffffff;
					recalc_board_gfx(game_gfx);
					d->flags |= D_DIRTY;
					return D_USED_CHAR | D_REDRAW;
				case KEY_LEFT:
					clear_keybuf();
					game_gfx->u2 += itofix(4);
					game_gfx->u2 &= 0xffffff;
					recalc_board_gfx(game_gfx);
					d->flags |= D_DIRTY;
					return D_USED_CHAR | D_REDRAW;
				case KEY_RIGHT:
					clear_keybuf();
					game_gfx->u2 -= itofix(4);
					game_gfx->u2 &= 0xffffff;
					recalc_board_gfx(game_gfx);
					d->flags |= D_DIRTY;
					return D_USED_CHAR | D_REDRAW;
			}
			if ((c & 0xff) == '?') {
				do_info_dialog();
				return D_USED_CHAR;
			}
			break;	/* dam sanci k dalsimu vyuziti ostatnich klaves... */
	}

	if (main_d_exit) return D_O_K;
	
	if ((game_gfx->gm->stones[WHITE] <= 0) || (game_gfx->gm->stones[BLACK] <= 0)) {
		/* uz je dohrano, takze jen doplnit kameny az nahoru */
		
		game_gfx->ghost = -1;	// trochu dirty ... aby tam nezustavaly pruhledny kameny na konci
		
		if (msg != MSG_IDLE)
			return D_O_K;

		if (game_gfx->st[STONES-1].state != NONE) {
			/* Hura, uz mame viteze, jenze to uz taky davno vime */
			/* takze at zijou animace... :-))) */
			game_gfx->u1 -= itofix(2);
			game_gfx->u1 &= 0xffffff;
			game_gfx->u2 -= itofix(4);
			game_gfx->u2 &= 0xffffff;
			recalc_board_gfx(game_gfx);
			return D_REDRAW;
		}
		
		for (i=0; (game_gfx->st[i].state != NONE); i++)
			if (i >= STONES) break;	/* tady neco smrdi... */
		p = (game_gfx->gm->stones[WHITE] <= 0)?BLACK:WHITE;
		game_gfx->st[i].state = p;
		game_gfx->gm->stones[p]--;

		/* a ted vsechno prekreslit ... */
		d->flags |= D_DIRTY;
		scare_mouse();
		acquire_screen();
		object_message(white_w, MSG_DRAW, 0);
		object_message(black_w, MSG_DRAW, 0);
		release_screen();
		unscare_mouse();

		/* a jeste zajasat, pokud uz to byl horni kamen */

		if (game_gfx->st[STONES-1].state != NONE) {
			s = malloc(ustrsize(players[p].name) + ustrsizez(STRING_WON));
			usprintf(s, STRING_WON, players[p].name);
			d_info_add_line(info_w, s);
			free(s);
		}

		return D_REDRAW;

	} else {
		/* vypada to, ze se jeste hraje... */

		if (players[game_gfx->gm->p].ai) {	/* tak ted hraje CPU */
			struct t_game cpu_gm;
			int r;
		
			if (msg != MSG_IDLE)
				return D_O_K;
		
			if (cpu_move_step >= 0) {
				if (cpu_move_flag) {
					cpu_move_flag--;
					
					r = animate_move(game_gfx->gm, &cpu_mv, &cpu_move_step);
			
					d->flags |= D_DIRTY;
					scare_mouse();
					acquire_screen();
					object_message(white_w, MSG_DRAW, 0);
					object_message(black_w, MSG_DRAW, 0);
					release_screen();
					unscare_mouse();

					if (!r) {
						remove_int(cpu_move_timer);	/* odstrani timer */
			
						cpu_move_step = -1;
			
						if ((players[WHITE].ai == 0) || (players[BLACK].ai == 0)) {
							s = ustrdup(STRING_RESULT(val));
							s2 = malloc(ustrsize(s) + ustrsizez(STRING_NEXTP));
							usprintf(s2, STRING_NEXTP, s);
							d_info_add_text(info_w, s2);
							free(s);
							free(s2);
						}
						s = malloc(ustrsize(players[game_gfx->gm->p].name) + ustrsizez(STRING_NEXT));
						usprintf(s, STRING_NEXT, players[game_gfx->gm->p].name);
						d_info_add_line(info_w, s);
						free(s);
					}
				
					return D_REDRAW;
				}
				return D_O_K;
			} else {
				d_info_add_line_nm(info_w, players[game_gfx->gm->p].name, STRING_THINKING);

				copy_game(game_gfx->gm, &cpu_gm);
				val = best_move(&cpu_gm, &cpu_mv);
			
				/* nalezen tah, ted jej jeste provedst */
				cpu_move_flag = 0;
				cpu_move_step = 0;

				install_int(cpu_move_timer, CPU_MOVE_DELAY);	/* naistaluje timer */
				r = animate_move(game_gfx->gm, &cpu_mv, &cpu_move_step);
			
				/* a ted vsechno prekreslit ... */
				d->flags |= D_DIRTY;
				scare_mouse();
				acquire_screen();
				object_message(white_w, MSG_DRAW, 0);
				object_message(black_w, MSG_DRAW, 0);
				release_screen();
				unscare_mouse();
					
				if (!r) {
					remove_int(cpu_move_timer);	/* odstrani timer */
			
					cpu_move_step = -1;
			
					if ((players[WHITE].ai == 0) || (players[BLACK].ai == 0)) {
						s = ustrdup(STRING_RESULT(val));
						s2 = malloc(ustrsize(s) + ustrsizez(STRING_NEXTP));
						usprintf(s2, STRING_NEXTP, s);
						d_info_add_text(info_w, s2);
						free(s);
						free(s2);
					}
					s = malloc(ustrsize(players[game_gfx->gm->p].name) + ustrsizez(STRING_NEXT));
					usprintf(s, STRING_NEXT, players[game_gfx->gm->p].name);
					d_info_add_line(info_w, s);
					free(s);
				}
				return D_REDRAW;
			}
		} else {	/* ... je to clovicek */
			switch (msg) {
			case MSG_IDLE:
				if ((d->flags & D_GOTMOUSE) && (d_game_data->gmode != G_NONE)) {
					int mx, my, id;
					mx = gui_mouse_x() - d->x - (d->w >> 1);
					my = gui_mouse_y() - d->y - (d->h >> 1);
					id = get_stone_id(game_gfx, mx, my, (d_game_data->gmode == G_ADD),
							(d_game_data->m.s1<0)?1:game_gfx->st[d_game_data->m.s1].y-1,
							d_game_data->m.s1);
					if (d_game_data->gh_id != id) {
						d_game_data->gh_id = id;
						game_gfx->ghost = id;
						d->flags |= D_DIRTY;
						return D_REDRAW;
					}
				}
#if defined(ALLEGRO_UNIX) || defined(ALLEGRO_LINUX)
				usleep(1000);	/* Tohle facha na Linuxu, ale na Woknech asi ne...
						 * aneb snaha o trochu multitasking-friendly chovani */
#endif
				return D_O_K;
			case MSG_RPRESS:
				if (rclick_move(game_gfx->gm, &(d_game_data->m), &(d_game_data->amove),
							&(d_game_data->movebuf)) == MOVE_ERR) {
					d_info_add_line(info_w, "DEBUG: *** rclick - MOVE_ERR! ***");
					return D_O_K;
				}
				if (d_game_data->amove == AMOVE_END) {
					d_game_data->m.s1 = -1;
					d_game_data->amove = AMOVE_PUT;
					d_game_data->movebuf = 1;
					s = malloc(ustrsize(players[game_gfx->gm->p].name) + ustrsizez(STRING_NEXT));
					usprintf(s, STRING_NEXT, players[game_gfx->gm->p].name);
					d_info_add_line(info_w, s);
					free(s);
				}
				if (d_game_data->amove == AMOVE_PUT) {
					d_game_data->gmode = G_ADD;
					if (d_game_data->movebuf > 0)
						d_info_add_line(info_w, STRING_PUT);
				} else {
					d_game_data->gmode = G_GET;
					d_info_add_line(info_w, STRING_GET);
				}
				scare_mouse();
				acquire_screen();
				object_message(white_w, MSG_DRAW, 0);
				object_message(black_w, MSG_DRAW, 0);
				release_screen();
				unscare_mouse();
				d->flags |= D_DIRTY;
				return D_REDRAW;
			case MSG_LRELEASE:
				if (d_game_data->gh_id != -1) {
					int r;
					
					switch (d_game_data->amove) {
						case AMOVE_GET0:
							d_game_data->m.s1 = d_game_data->gh_id;
							break;
						case AMOVE_PUT:
							d_game_data->m.s2 = d_game_data->gh_id;
							break;
						case AMOVE_GET1:
							d_game_data->m.s31 = d_game_data->gh_id;
							break;
						case AMOVE_GET2:
							d_game_data->m.s32 = d_game_data->gh_id;
							break;
					}

					r = do_move(game_gfx->gm, &(d_game_data->m), &(d_game_data->amove),
							&(d_game_data->movebuf));

					if (r == MOVE_ERR) {
						d_info_add_line(info_w, "DEBUG: *** lclick - MOVE_ERR! ***");
						d->flags |= D_DIRTY;
						return D_REDRAW;
					}
			
					if (d_game_data->amove == AMOVE_END) {
						d_game_data->m.s1 = -1;
						d_game_data->amove = AMOVE_PUT;
						d_game_data->movebuf = 1;
						s = malloc(ustrsize(players[game_gfx->gm->p].name) + ustrsizez(STRING_NEXT));
						usprintf(s, STRING_NEXT, players[game_gfx->gm->p].name);
						d_info_add_line(info_w, s);
						free(s);
					}
					if (d_game_data->amove == AMOVE_PUT) {
						d_game_data->gmode = G_ADD;
						d_game_data->gh_id = -1;
						game_gfx->ghost = -1;
					} else {
						d_game_data->gmode = G_GET;
						switch (d_game_data->amove) {
							case AMOVE_GET1:
								d_info_add_line(info_w, STRING_GET1); break;
							case AMOVE_GET2:
								d_info_add_line(info_w, STRING_GET2); break;
						}
						if (d_game_data->amove == AMOVE_GET1) { /* hnusnej workaround pro vyhezceni... */
							i = game_gfx->ghost; game_gfx->ghost = -1;
							scare_mouse();
							acquire_screen();
							draw_stones(game_gfx);
							blit_board(game_gfx, d->x, d->y);
							release_screen();
							unscare_mouse();
							rest(250);
							game_gfx->ghost = i;
						}
							
					}
					d->flags |= D_DIRTY;
					scare_mouse();
					acquire_screen();
					object_message(white_w, MSG_DRAW, 0);
					object_message(black_w, MSG_DRAW, 0);
					release_screen();
					unscare_mouse();
					return D_REDRAW;
				}
				return D_O_K;
			}
		}
	}

	return D_O_K;
}



int d_buf_proc(int msg, DIALOG *d, int c)
{
	struct t_game_gfx *game_gfx = d->dp;
	struct t_d_game_data *d_game_data = d->dp2;

	switch (msg) {
		case MSG_START:
			return D_O_K;
		case MSG_DRAW:
			draw_bufs(game_gfx, (d_game_data->movebuf>0)?game_gfx->gm->p:NONE, d->x, d->y, d->d1);
			return D_O_K;
	}
	return D_O_K;
}

int d_info_proc(int msg, DIALOG *d, int c)
{
	struct t_d_info_data *data = d->dp;
	int i, x, y;
	BITMAP *inf_bg;
	
	switch (msg) {
		case MSG_START:
			d->dp = malloc(sizeof(struct t_d_info_data));
			data = d->dp;
			data->line = malloc(d->d1 * sizeof(char *));
			for (i=0; i<d->d1; i++)
				data->line[i] = ustrdup(empty_string);
			data->aline = 0;
			break;
		case MSG_END:
			for (i=0; i<d->d1; i++)
				free(data->line[i]);
			free(data);
			inf_bg = create_bitmap(d->w, d->h);
			clear_bitmap(inf_bg);
			draw_sprite(screen, inf_bg, d->x, d->y);
			destroy_bitmap(inf_bg);
			break;
		case MSG_DRAW:
			inf_bg = create_bitmap(d->w, d->h);
			clear_bitmap(inf_bg);
			y = (d->h - (d->d1 * d->d2))/2;
			if (y<0)
				y = 0;
			x = y * 2;			
			for (i=0; i<d->d1; i++)
				if (data->line[i] != NULL)
					textout(inf_bg, font, data->line[i], x, y+i*d->d2, d->fg);
			draw_sprite(screen, inf_bg, d->x, d->y);
			destroy_bitmap(inf_bg);
			break;
	}
	return D_O_K;
}

int d_esc_proc(int msg, DIALOG *d, int c)
{
	int r;
	
	if ((msg == MSG_XCHAR) && ((c>>8) == KEY_ESC)) {

		r = alert3(NULL, "Ukoncit hru?", NULL, "&Ano", "Na u&vod", "&Ne", 'a', 'v', 'n');
		switch (r) {
			case 3:
				return D_USED_CHAR;
			case 1:
			case 2:
				main_d_exit = r;
				return D_CLOSE;
		}
		return D_USED_CHAR;
	}

	return D_O_K;
}

void d_info_add_text(DIALOG *d, const char *text)
{
	struct t_d_info_data *data = d->dp;
	
	data->line[data->aline] = realloc(data->line[data->aline], ustrsize(data->line[data->aline]) + ustrsizez(text));
	ustrcat(data->line[data->aline], text);
	scare_mouse();
	acquire_screen();
	object_message(d, MSG_DRAW, 0);
	release_screen();
	unscare_mouse();
}

void d_info_add_line(DIALOG *d, const char *text)
{
	struct t_d_info_data *data = d->dp;
	int i;
	
	data->aline++;
	if (data->aline >= d->d1) {
		free(data->line[0]);
		for (i=0; i<(d->d1-1); i++)
			data->line[i] = data->line[i+1];
		data->aline = i;
	}
	data->line[data->aline] = ustrdup(text);
	scare_mouse();
	acquire_screen();
	object_message(d, MSG_DRAW, 0);
	release_screen();
	unscare_mouse();
}

void d_info_add_line_nm(DIALOG *d, const char *nm, const char *text)
{
	struct t_d_info_data *data = d->dp;
	int i;
	char *sep = ": ";
	
	data->aline++;
	if (data->aline >= d->d1) {
		free(data->line[0]);
		for (i=0; i<(d->d1-1); i++)
			data->line[i] = data->line[i+1];
		data->aline = i;
	}
	data->line[data->aline] = malloc(ustrsize(nm) + ustrsize(sep) + ustrsizez(text));
	ustrcpy(data->line[data->aline], nm);
	ustrcat(data->line[data->aline], sep);
	ustrcat(data->line[data->aline], text);
	scare_mouse();
	acquire_screen();
	object_message(d, MSG_DRAW, 0);
	release_screen();
	unscare_mouse();
}

