#ifndef __UI_H__
#define __UI_H__

#include <allegro.h>
#include <stdlib.h>
#include <string.h>

#include "gfx.h"
#include "data.h"
#include "game.h"
#include "pyr.h"
#include "ai.h"

extern DIALOG *game_w, *white_w, *black_w, *info_w;

#define MAIN_D_ITMS	7
extern DIALOG *main_d;

/* pochybna promenna, aby se dalo zjistit, jestli user chce konec nebo menu */
extern int main_d_exit;

#define G_NONE	-1
#define G_ADD	 0
#define G_GET	 1

struct t_d_game_data {
	int gmode;
	int gh_id;		// id aktualne duchovatyho kamenu
	struct t_move m;	// planovany tah
	int amove;		// stav tahu
	int movebuf;
};

struct t_d_info_data {
	char **line;
	int aline;
};

/* provadi uvodni menu dialog */
int do_menu_dialog(struct t_player *players);

/* zobrazi dialog s textovym polem s pokecem o programu & pravidlech */
void do_info_dialog();



/* vygeneruje pamet pro hlavni "dialog" a vyplni prvky pro vsechna okynka;
 * chce pointer na inicializovanou strukturu hry a info o hracich */
DIALOG *init_main_d(struct t_game_gfx *game_gfx, struct t_player *players);

/* obsluhuje hraci plochu a hru; dp je pointer na game_gfx a dp2 na d_game_data a dp3 na players */
int d_game_proc(int msg, DIALOG *d, int c);

/* obsluhuje zasobniky kamenu; d1 je budto WHITE nebo BLACK, dp je pointer na game_gfx a dp2 na d_game_data,
 * 	dp3 pointer na t_player data pro odpovidajiciho hrace */
int d_buf_proc(int msg, DIALOG *d, int c);

/* obsluhuje spodni textovy okynko; dp je pointer na d_info_data (inicializovany pri MSG_START),
 * 	d1 je pocet radek, d2 mezera mezi radky */
int d_info_proc(int msg, DIALOG *d, int c);

/* prida text/radku do info-okynka */
void d_info_add_text(DIALOG *d, const char *text);
void d_info_add_line(DIALOG *d, const char *text);
void d_info_add_line_nm(DIALOG *d, const char *nm, const char *text);


/* objekt, ktery se jen stara o Esc a kdyz je stisknuty, tak vyhodi okynko */
int d_esc_proc(int msg, DIALOG *d, int c);



void lock_timer_stuff();

#endif

